package com.pj.tb_goods_cart;

import java.util.List;

import com.pj.tb_goods_cart.vo.GoodsCartVo;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.pj.utils.sg.*;
import com.pj.project4sp.SP;

import cn.dev33.satoken.annotation.SaCheckPermission;


/**
 * Controller: tb_goods_cart -- 购物车
 * @author qzy
 */
@RestController
@RequestMapping("/TbGoodsCart/")
public class TbGoodsCartController {

	/** 底层 Service 对象 */
	@Autowired
	TbGoodsCartService tbGoodsCartService;

	/** 增 */
	@RequestMapping("add")
//	@SaCheckPermission(TbGoodsCart.PERMISSION_CODE_ADD)
	public AjaxJson add(TbGoodsCart t){
		tbGoodsCartService.add(t);
		t = tbGoodsCartService.getById(SP.publicMapper.getPrimarykey());
		return AjaxJson.getSuccessData(t);
	}

	/** 删 */
	@RequestMapping("delete")
//	@SaCheckPermission(TbGoodsCart.PERMISSION_CODE_DEL)
	public AjaxJson delete(Long id){
		tbGoodsCartService.delete(id);
		return AjaxJson.getSuccess();
	}

	/** 删 - 根据id列表 */
	@RequestMapping("deleteByIds")
//	@SaCheckPermission(TbGoodsCart.PERMISSION_CODE_DEL)
	public AjaxJson deleteByIds(){
		List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
		int line = SP.publicMapper.deleteByIds(TbGoodsCart.TABLE_NAME, ids);
		return AjaxJson.getByLine(line);
	}

	/** 改 */
	@RequestMapping("update")
//	@SaCheckPermission(TbGoodsCart.PERMISSION_CODE_EDIT)
	public AjaxJson update(TbGoodsCart t){
		tbGoodsCartService.update(t);
		return AjaxJson.getSuccess();
	}

	/** 查 - 根据id */
	@RequestMapping("getById")
//		@SaCheckPermission(TbGoodsCart.PERMISSION_CODE)
	public AjaxJson getById(String id){
		TbGoodsCart t = tbGoodsCartService.getById(id);
		return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */
	@RequestMapping("getList")
//		@SaCheckPermission(TbGoodsCart.PERMISSION_CODE)
	public AjaxJson getList() {
		SoMap so = SoMap.getRequestSoMap();
		List<GoodsCartVo> list = tbGoodsCartService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}



	/** 改 - 删除状态(0=禁用,1=启用) */
	@RequestMapping("updateDeleteStatus")
//	@SaCheckPermission(TbGoodsCart.PERMISSION_CODE_EDIT)
	public AjaxJson updateDeleteStatus(String id, Integer value){
		int line = SP.publicMapper.updateColumnById(TbGoodsCart.TABLE_NAME, "delete_status", value, id);
		return AjaxJson.getByLine(line);
	}

}
